
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class User_achievementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_achievements = await db.user_achievements.create(
            {
                id: data.id || undefined,
        
        progress_value: data.progress_value
        ||
        null
            ,
            
        is_completed: data.is_completed
        ||
        false
        
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await user_achievements.setUser( data.user || null, {
            transaction,
        });
        
        await user_achievements.setAchievement( data.achievement || null, {
            transaction,
        });
        

        

        

        return user_achievements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const user_achievementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                progress_value: item.progress_value
            ||
            null
            ,
            
                is_completed: item.is_completed
            ||
            false
        
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const user_achievements = await db.user_achievements.bulkCreate(user_achievementsData, { transaction });

        // For each item created, replace relation files
        

        return user_achievements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const user_achievements = await db.user_achievements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.progress_value !== undefined) updatePayload.progress_value = data.progress_value;
        
        
        if (data.is_completed !== undefined) updatePayload.is_completed = data.is_completed;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await user_achievements.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await user_achievements.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.achievement !== undefined) {
            await user_achievements.setAchievement(
              
              data.achievement,
              
              { transaction }
            );
        }
        

        
        

        

        return user_achievements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_achievements = await db.user_achievements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of user_achievements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of user_achievements) {
                await record.destroy({transaction});
            }
        });


        return user_achievements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const user_achievements = await db.user_achievements.findByPk(id, options);

        await user_achievements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await user_achievements.destroy({
            transaction
        });

        return user_achievements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const user_achievements = await db.user_achievements.findOne(
            { where },
            { transaction },
        );

        if (!user_achievements) {
            return user_achievements;
        }

        const output = user_achievements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await user_achievements.getUser({
            transaction
        });
        
        
        output.achievement = await user_achievements.getAchievement({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.achievements,
        as: 'achievement',
        
        where: filter.achievement ? {
          [Op.or]: [
            { id: { [Op.in]: filter.achievement.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.achievement.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.progress_valueRange) {
                const [start, end] = filter.progress_valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    progress_value: {
                    ...where.progress_value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    progress_value: {
                    ...where.progress_value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_completed) {
                where = {
                    ...where,
                is_completed: filter.is_completed,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.user_achievements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'user_achievements',
                        'is_completed',
                        query,
                    ),
                ],
            };
        }

        const records = await db.user_achievements.findAll({
            attributes: [ 'id', 'is_completed' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['is_completed', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.is_completed,
        }));
    }

    
};

